/************************************************************************************/
/*  Program name CAPFNDIMP_REQ_SET_STAGE_TL.sql                                     */
/*  Creater:  Chan Billy Ka Keung (PCCW - UniHub)                                   */
/*************   History   *************************                                */
/* 01 FEB, 2006   CHAN Billy Ka Keung         First created                         */
/************************************************************************************/

SET SERVEROUTPUT ON SIZE 1000000;

DECLARE

	lv_PrOG_ID		VARCHAR2(100) 	:=	'CAPFNDIMP_REQ_SET_STAGE_TL';

	lv_Scc_Count	NUMBER			:=	0;
	lv_Err_Count	NUMBER			:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	CURSOR Cur_F IS
	SELECT
		*
	FROM
		CRST_FND_REQ_SET_STAGE_TL;

	lv_Next_Seq_ID	NUMBER;

BEGIN
	--RENAME
	UPDATE	FND_REQUEST_SET_STAGES_TL
	SET		User_Stage_Name = REQUEST_SET_ID||User_Stage_Name
	WHERE	(Set_Application_ID,Language,Request_Set_ID,Request_Set_Stage_ID,User_Stage_Name) IN
							(
							SELECT
								Set_Application_ID,Language,Request_Set_ID,Request_Set_Stage_ID,User_Stage_Name
							FROM
								CRST_FND_REQ_SET_STAGE_TL
							);

	FOR C1 IN Cur_F LOOP
		BEGIN
			INSERT INTO FND_REQUEST_SET_STAGES_TL
			VALUES
			(
			C1.SET_APPLICATION_ID,
			CAPBRIMP_MAPPING.GetRequestSetIDMapping(C1.REQUEST_SET_ID),				--REQUEST_SET_ID,
			CAPBRIMP_MAPPING.GetRequestSetStageIDMapping(C1.REQUEST_SET_STAGE_ID),	--REQUEST_SET_STAGE_ID,
			C1.LANGUAGE,
			C1.SOURCE_LANG,
			C1.CREATION_DATE,
			CAPBRIMP_COMMON.GetUser(C1.CREATED_BY_NAME),							--CREATED_BY,
			C1.LAST_UPDATE_DATE,
			CAPBRIMP_COMMON.GetUser(C1.LAST_UPDATED_BY_NAME),						--LAST_UPDATED_BY,
			C1.LAST_UPDATE_LOGIN,
			C1.USER_STAGE_NAME,
			C1.DESCRIPTION
			);
		EXCEPTION
			WHEN OTHERS THEN
				DBMS_OUTPUT.Put_lINe(SQLERRM);
				lv_Err_Count	:=	lv_Err_Count + 1;
		END;
		lv_Scc_Count		:= lv_Scc_Count + 1;
	END LOOP;

	IF lv_Err_Count	>	0	THEN
		ROLLBACK;
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count - lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/
